/* VAARALLISTA!  ... eli HAUSKAA (tiettyyn pisteeseen asti..). 
 *
 * Ei saa kokeilla yhteiskäyttökoneilla! Kotikoneella MUISTA että
 * tiedostojärjestelmäsi on periaatteessa aina vaarassa, jos joudut
 * buuttaamaan, eli omalla vastuullasi olet datoinesi!
 * Suorakäyttökoneella itka203.it.jyu.fi voi kokeilla tätä ja mitä
 * vain turvallisessa ympäristössä. Jos kone jostain syystä kyykähtää,
 * sen voi kylmäkäynnistää etänä (kestää noin pari minuuttia). Soita
 * 040-5768507, niin homma hoituu.
 *
 * Tässä esimerkissä luodaan lapsiprosesseja niin kauan kuin
 * pystyy. Jos järjestelmässä ei ole rajoitettu käyttäjien oikeuksia
 * prosessien käytössä, tässä käy lopulta niin, että koko
 * prosessitaulu on täynnä aktiivisia prosesseja, ja siinä vaiheessa
 * tietokoneella ei tee kukaan paljon mitään. Paljon ääneen kiroilua
 * tapahtuu.
 *
 * Kaitpa, jos tämä olisi pahantahtoisen hakkerin tekosia,
 * sanottaisiin että tämä on yhdenlainen DoS eli Denial-of-service
 * -hyökkäys. Kukaan ei tee palvelimella mitään, jos joku pääsi
 * pommittamaan prosessitaulun täyteen.
 *
 * HUOM: fork()-kutsun käytön ymmärtäminen kuuluu kurssin
 * pakolliseenkin sisältöön!
 *
 */

#include<stdio.h>
#include<stdlib.h>

#include "./turvavyo.c"

int main(int argc, char *argv[]){
  int pid;
  int n = 0;

  lopeta_jos_ei_turvallinen_kone();

  for(;;){
    switch (pid=fork()) {
    case 0: 
      /* Uusi prosessi jätetään odottelemaan signaalia. */
      pause();
      exit(0);
    case -1: 
      perror("fork() failed");
      break;
    default:
      printf("Tein lapsiprosessin, jonka PID on %d (yht. %d kpl) \r", pid, ++n);
    } 
  }
}
